'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactRedux = require('react-redux');

var _reactRouterDom = require('react-router-dom');

var _history = require('history');

var _redux = require('redux');

var _reactRouterRedux = require('react-router-redux');

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

var _systemjs = require('systemjs');

var _systemjs2 = _interopRequireDefault(_systemjs);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AppRegistry = {
  registerComponent: function registerComponent(appKey, componentProvider, config) {
    if (config.systemConfig) {
      _systemjs2.default.config(config.systemConfig);
    }
    var App = componentProvider();
    var historyType = App.historyType;

    var AppWithRouter = (0, _reactRouterDom.withRouter)(App);
    var history = historyType === 'hash' ? (0, _history.createHashHistory)() : historyType === 'browser' ? (0, _history.createBrowserHistory)() : (0, _history.createMemoryHistory)();

    var loggerMiddleware = function loggerMiddleware(store) {
      return function (next) {
        return function (action) {
          if (process.env.NODE_ENV !== 'production') console.warn(action);
          return next(action);
        };
      };
    };

    var create = global.devToolsExtension ? global.devToolsExtension()(_redux.createStore) : _redux.createStore;

    var createReducer = function createReducer(asyncReducers) {
      return (0, _redux.combineReducers)(_extends({
        router: _reactRouterRedux.routerReducer,
        routing: _reactRouterRedux.routerReducer
      }, asyncReducers));
    };

    var createStoreWithMiddleware = (0, _redux.applyMiddleware)(_reduxThunk2.default, loggerMiddleware, (0, _reactRouterRedux.routerMiddleware)(history))(create);

    var store = createStoreWithMiddleware(createReducer({}), {});
    store.asyncReducers = {};

    var injectReducer = function injectReducer(name, asyncReducer) {
      var force = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      (0, _warning2.default)(!store.hasOwnProperty(name) || force, name + ' has been injected, if you want to replace it, use force=true argument');
      store.asyncReducers[name] = asyncReducer;
      store.replaceReducer(createReducer(store.asyncReducers));
    };

    _reactDom2.default.render(_react2.default.createElement(
      _reactRedux.Provider,
      { store: store },
      _react2.default.createElement(
        _reactRouterRedux.ConnectedRouter,
        { history: history },
        _react2.default.createElement(AppWithRouter, { store: store, injectReducer: injectReducer })
      )
    ), config.mountPoint);
  }
};

exports.default = AppRegistry;